//-------------------------------------------------------------//
//                                                             //
//     ExtPage.HPP                                             //
//     Header of components Extended PageControl and           //
//     Extended TabControl v2.3 for Borland C++Builder 1       //
//                                                             //
//     Copy this file into your C++Builder Include directory   //
//                                                             //
//-------------------------------------------------------------//
#ifndef ExtPageHPP
#define ExtPageHPP
//----------------------------------------------------------------------------
#include <CommCtrl.hpp>
#include <ComCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <StdCtrls.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <System.hpp>
namespace Extpage
{
//-- type declarations -------------------------------------------------------
enum TExtGlyphPosition { glPosLeft, glPosTop };

class __declspec(delphiclass) TExtGlyphs;
class __declspec(pascalimplementation) TExtGlyphs : public Classes::TPersistent
{
  typedef Classes::TPersistent inherited;
  
private:
  Graphics::TBitmap* FGlyph;
  Graphics::TBitmap* FGlyphPaint;
  Controls::TControl* FGlpyhOwner;
  Controls::TImageList* FImageList;
  Word FNumGlyphs;
  Classes::TNotifyEvent FOnChange;
  Classes::TNotifyEvent FOnChangeGlyph;
  TExtGlyphPosition FPosition;
  int FSpacing;
  Graphics::TColor FTransparentColor;
  void __fastcall SetGlyph(Graphics::TBitmap* Value);
  void __fastcall SetImageList(Controls::TImageList* Value);
  void __fastcall SetNumGlyphs(Word Value);
  void __fastcall SetPosition(TExtGlyphPosition Value);
  void __fastcall SetSpacing(int Value);
  void __fastcall SetTransparentColor(Graphics::TColor Value);
  
protected:
  void __fastcall Changed(System::TObject* Sender);
  void __fastcall ChangedGlyph(System::TObject* Sender);
  
public:
  __fastcall TExtGlyphs(Controls::TControl* AOwner);
  __fastcall virtual ~TExtGlyphs(void);
  __property Controls::TImageList* ImageList = {read=FImageList, write=SetImageList, nodefault};
  __property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
  __property Classes::TNotifyEvent OnChangeGlyph = {read=FOnChangeGlyph, write=FOnChangeGlyph};
  
__published:
  __property Graphics::TBitmap* Glyph = {read=FGlyph, write=SetGlyph, nodefault};
  __property Word NumGlyphs = {read=FNumGlyphs, write=SetNumGlyphs, default=0};
  __property TExtGlyphPosition Position = {read=FPosition, write=SetPosition, default=0};
  __property int Spacing = {read=FSpacing, write=SetSpacing, default=5};
  __property Graphics::TColor TransparentColor = {read=FTransparentColor, write=SetTransparentColor, 
    default=16711935};
};

class __declspec(delphiclass) TExtHottrack;
class __declspec(pascalimplementation) TExtHottrack : public Classes::TPersistent
{
  typedef Classes::TPersistent inherited;
  
private:
  bool FEnabled;
  Controls::TControl* FHottrackOwner;
  Graphics::TColor FTabActiveColor;
  Graphics::TColor FTabInactiveColor;
  void __fastcall SetEnabled(bool Value);
  void __fastcall SetTabActiveColor(Graphics::TColor Value);
  void __fastcall SetTabInactiveColor(Graphics::TColor Value);
  
public:
  int TabTracked;
  __fastcall TExtHottrack(Controls::TControl* AOwner);
  
__published:
  __property bool Enabled = {read=FEnabled, write=SetEnabled, default=0};
  __property Graphics::TColor TabActiveColor = {read=FTabActiveColor, write=SetTabActiveColor, default=-2147483635
    };
  __property Graphics::TColor TabInactiveColor = {read=FTabInactiveColor, write=SetTabInactiveColor, 
    default=-2147483635};
public:
  /* TObject.Destroy */ __fastcall virtual ~TExtHottrack(void) { }
  
};

class __declspec(delphiclass) EExtPageInvalidCall;
class __declspec(pascalimplementation) EExtPageInvalidCall : public Sysutils::Exception
{
  typedef Sysutils::Exception inherited;
  
public:
  /* Exception.Create */ __fastcall EExtPageInvalidCall(const System::AnsiString Msg) : Sysutils::Exception(
    Msg) { }
  /* Exception.CreateFmt */ __fastcall EExtPageInvalidCall(const System::AnsiString Msg, const System::TVarRec 
    * Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
  /* Exception.CreateRes */ __fastcall EExtPageInvalidCall(int Ident) : Sysutils::Exception(Ident) { }
    
  /* Exception.CreateResFmt */ __fastcall EExtPageInvalidCall(int Ident, const System::TVarRec * Args
    , const int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
  /* Exception.CreateHelp */ __fastcall EExtPageInvalidCall(const System::AnsiString Msg, int AHelpContext
    ) : Sysutils::Exception(Msg, AHelpContext) { }
  /* Exception.CreateFmtHelp */ __fastcall EExtPageInvalidCall(const System::AnsiString Msg, const System::TVarRec 
    * Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
    ) { }
  /* Exception.CreateResHelp */ __fastcall EExtPageInvalidCall(int Ident, int AHelpContext) : Sysutils::
    Exception(Ident, AHelpContext) { }
  /* Exception.CreateResFmtHelp */ __fastcall EExtPageInvalidCall(int Ident, const System::TVarRec * 
    Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext
    ) { }
  
public:
  /* TObject.Destroy */ __fastcall virtual ~EExtPageInvalidCall(void) { }
  
};

typedef void __fastcall (__closure *TExtNbDrawTabEvent)(Controls::TWinControl* Control, int Index, bool 
  ActiveTab, const Windows::TRect &RectFg, const Windows::TRect &RectBg, Stdctrls::TOwnerDrawState State
  );

typedef void __fastcall (__closure *TExtDrawBkgndInside)(Controls::TWinControl* Control, HDC DC, int 
  CurrPage, const Windows::TRect &RectBg);

typedef void __fastcall (__closure *TExtDrawBkgndOutside)(Controls::TWinControl* Control, HDC DC, HRGN 
  RgnBg);

enum TExtTabStyle { tabStDefault, tabStButton };

enum TExtTabPosition { tabPosLeft, tabPosRight, tabPosTop, tabPosBottom };

class __declspec(delphiclass) TExtPageControl;
class __declspec(pascalimplementation) TExtPageControl : public Comctrls::TPageControl
{
  typedef Comctrls::TPageControl inherited;
  
private:
  Graphics::TCanvas* FCanvas;
  TExtHottrack* FHottrack;
  System::AnsiString FHintOrg;
  bool FirstPaint;
  int FLastTabHintIndex;
  bool FMouseInControl;
  TExtDrawBkgndInside FOnDrawBkgndInside;
  TExtDrawBkgndOutside FOnDrawBkgndOutside;
  TExtNbDrawTabEvent FOnDrawTab;
  Graphics::TColor FTabActiveColor;
  Graphics::TFont* FTabActiveFont;
  TExtGlyphs* FTabGlyphs;
  Word FTabHeight;
  Classes::TStringList* FTabHints;
  Graphics::TColor FTabInactiveColor;
  Graphics::TFont* FTabInactiveFont;
  TExtTabPosition FTabPosition;
  TExtTabStyle FTabStyle;
  Word FTabWidth;
  bool FTabWordWrap;
  int StopBGPainting;
  bool StopBGPaintingTabs;
  int StopFGPainting;
  void __fastcall CheckAndSetHWndFont(void);
  Comctrls::TTabSheet* __fastcall GetActivePage(void);
  HIDESBASE void __fastcall SetActivePage(Comctrls::TTabSheet* Value);
  void __fastcall SetHottrack(TExtHottrack* Value);
  void __fastcall SetTabActiveColor(Graphics::TColor Value);
  void __fastcall SetTabActiveFont(Graphics::TFont* Value);
  void __fastcall SetTabGlyphs(TExtGlyphs* Value);
  HIDESBASE void __fastcall SetTabHeight(Word Value);
  void __fastcall SetTabHints(Classes::TStringList* Value);
  void __fastcall SetTabInactiveColor(Graphics::TColor Value);
  void __fastcall SetTabInactiveFont(Graphics::TFont* Value);
  void __fastcall SetTabPosition(TExtTabPosition Value);
  void __fastcall SetTabStyle(TExtTabStyle Value);
  HIDESBASE void __fastcall SetTabWidth(Word Value);
  void __fastcall SetTabWordWrap(bool Value);
  HIDESBASE MESSAGE void __fastcall CMDialogChar(Messages::TWMKey &Msg);
  HIDESBASE MESSAGE void __fastcall CMFontChanged(Messages::TMessage &Msg);
  MESSAGE void __fastcall CMHintShow(Messages::TMessage &Msg);
  HIDESBASE MESSAGE void __fastcall CMMouseEnter(Messages::TMessage &Msg);
  HIDESBASE MESSAGE void __fastcall CMMouseLeave(Messages::TMessage &Msg);
  HIDESBASE MESSAGE void __fastcall CMParentColorChanged(Messages::TMessage &Msg);
  MESSAGE void __fastcall CNDrawTab(Messages::TWMDrawItem &Msg);
  MESSAGE void __fastcall TCMInsertItem(Messages::TMessage &Msg);
  HIDESBASE MESSAGE void __fastcall WMEraseBkgnd(Messages::TWMEraseBkgnd &Msg);
  MESSAGE void __fastcall WMHelp(Messages::TWMHelp &Msg);
  HIDESBASE MESSAGE void __fastcall WMLButtonDown(Messages::TWMMouse &Msg);
  HIDESBASE MESSAGE void __fastcall WMNCHitTest(Messages::TWMNCHitTest &Msg);
  HIDESBASE MESSAGE void __fastcall WMPaint(Messages::TWMPaint &Msg);
  
protected:
  virtual void __fastcall ChangeScale(int M, int D);
  virtual void __fastcall CreateParams(Controls::TCreateParams &Params);
  virtual void __fastcall CreateWnd(void);
  virtual void __fastcall FillTabBG(HDC DC, bool ActiveTab, const Windows::TRect &TabRect);
  void __fastcall GlyphHasChanged(System::TObject* Sender);
  void __fastcall GlyphHasChangedPicture(System::TObject* Sender);
  virtual void __fastcall Loaded(void);
  virtual void __fastcall TabFontChanged(System::TObject* Sender);
  virtual tagPOINT __fastcall TabTextOut(const Windows::TRect &Rect, const tagPOINT &Margin,  System::AnsiString 
    Text, Classes::TAlignment Align, bool Disabled);
  
public:
  bool PaintFlickerFree;
  __fastcall virtual TExtPageControl(Classes::TComponent* AOwner);
  __fastcall virtual ~TExtPageControl(void);
  virtual void __fastcall BeginUpdate(void);
  virtual void __fastcall DefaultDrawTab(int Index, const Windows::TRect &RectFg, Stdctrls::TOwnerDrawState 
    State);
  virtual void __fastcall DestroyAllOtherSheetHandles(void);
  virtual void __fastcall DrawTab(int Index, bool ActiveTab, const Windows::TRect &RectFg, const Windows::TRect 
    &RectBg, Stdctrls::TOwnerDrawState State);
  virtual void __fastcall EndUpdate(void);
  virtual int __fastcall GetGlyphIndex(int PgIndex);
  int __fastcall GetPageIndexByTabIndex(int CurrentTabIndex);
  virtual void __fastcall GetSheetRect(Windows::TRect &SheetRect);
  virtual int __fastcall GetTabNumber(const tagPOINT &CurrentPos);
  virtual Windows::TRect __fastcall GetTabRect(int TabIndex);
  virtual void __fastcall HottrackChange(int Cold, int Hot);
  bool __fastcall IsNewComCtl(void);
  virtual void __fastcall ReAlignTabSheets(bool Adamant);
  void __fastcall SelectNextEnabledPage(bool GoForward, bool FullCycle);
  __property Graphics::TCanvas* Canvas = {read=FCanvas, nodefault};
  __property Tabs ;
  
__published:
  __property Comctrls::TTabSheet* ActivePage = {read=GetActivePage, write=SetActivePage, nodefault};
  __property Color ;
  __property TExtHottrack* Hottrack = {read=FHottrack, write=SetHottrack, nodefault};
  __property ParentColor ;
  __property Graphics::TColor TabActiveColor = {read=FTabActiveColor, write=SetTabActiveColor, nodefault
    };
  __property Graphics::TFont* TabActiveFont = {read=FTabActiveFont, write=SetTabActiveFont, nodefault
    };
  __property TExtGlyphs* TabGlyphs = {read=FTabGlyphs, write=SetTabGlyphs, nodefault};
  __property Word TabHeight = {read=FTabHeight, write=SetTabHeight, nodefault};
  __property Classes::TStringList* TabHints = {read=FTabHints, write=SetTabHints, nodefault};
  __property Graphics::TColor TabInactiveColor = {read=FTabInactiveColor, write=SetTabInactiveColor, 
    nodefault};
  __property Graphics::TFont* TabInactiveFont = {read=FTabInactiveFont, write=SetTabInactiveFont, nodefault
    };
  __property TExtTabPosition TabPosition = {read=FTabPosition, write=SetTabPosition, default=2};
  __property TExtTabStyle TabStyle = {read=FTabStyle, write=SetTabStyle, default=0};
  __property Word TabWidth = {read=FTabWidth, write=SetTabWidth, nodefault};
  __property bool TabWordWrap = {read=FTabWordWrap, write=SetTabWordWrap, default=0};
  __property TExtDrawBkgndInside OnDrawBkgndInside = {read=FOnDrawBkgndInside, write=FOnDrawBkgndInside
    };
  __property TExtDrawBkgndOutside OnDrawBkgndOutside = {read=FOnDrawBkgndOutside, write=FOnDrawBkgndOutside
    };
  __property TExtNbDrawTabEvent OnDrawTab = {read=FOnDrawTab, write=FOnDrawTab};
public:
  /* TWinControl.CreateParented */ __fastcall TExtPageControl(HWND ParentWindow) : Comctrls::TPageControl(
    ParentWindow) { }
  
};

class __declspec(delphiclass) TExtPageControlTag;
class __declspec(pascalimplementation) TExtPageControlTag : public TExtPageControl
{
  typedef TExtPageControl inherited;
  
public:
  virtual int __fastcall GetGlyphIndex(int PgIndex);
public:
  /* TExtPageControl.Create */ __fastcall virtual TExtPageControlTag(Classes::TComponent* AOwner) : Extpage::
    TExtPageControl(AOwner) { }
  /* TExtPageControl.Destroy */ __fastcall virtual ~TExtPageControlTag(void) { }
  
public:
  /* TWinControl.CreateParented */ __fastcall TExtPageControlTag(HWND ParentWindow) : Extpage::TExtPageControl(
    ParentWindow) { }
  
};

class __declspec(delphiclass) TExtTabControl;
class __declspec(pascalimplementation) TExtTabControl : public Comctrls::TTabControl
{
  typedef Comctrls::TTabControl inherited;
  
private:
  Graphics::TCanvas* FCanvas;
  TExtHottrack* FHottrack;
  System::AnsiString FHintOrg;
  bool FirstPaint;
  int FLastTabHintIndex;
  bool FMouseInControl;
  TExtDrawBkgndInside FOnDrawBkgndInside;
  TExtDrawBkgndOutside FOnDrawBkgndOutside;
  TExtNbDrawTabEvent FOnDrawTab;
  Graphics::TColor FTabActiveColor;
  Graphics::TFont* FTabActiveFont;
  Classes::TList* FTabDisabledList;
  TExtGlyphs* FTabGlyphs;
  Word FTabHeight;
  Classes::TStringList* FTabHints;
  Graphics::TColor FTabInactiveColor;
  Graphics::TFont* FTabInactiveFont;
  TExtTabPosition FTabPosition;
  TExtTabStyle FTabStyle;
  Word FTabWidth;
  bool FTabWordWrap;
  int StopBGPainting;
  bool StopBGPaintingTabs;
  int StopFGPainting;
  void __fastcall CheckAndSetHWndFont(void);
  bool __fastcall GetTabEnabled(int Index);
  HIDESBASE int __fastcall GetTabIndex(void);
  void __fastcall SetHottrack(TExtHottrack* Value);
  void __fastcall SetTabActiveColor(Graphics::TColor Value);
  void __fastcall SetTabActiveFont(Graphics::TFont* Value);
  void __fastcall SetTabEnabled(int Index, bool Value);
  void __fastcall SetTabGlyphs(TExtGlyphs* Value);
  HIDESBASE void __fastcall SetTabHeight(Word Value);
  void __fastcall SetTabHints(Classes::TStringList* Value);
  void __fastcall SetTabInactiveColor(Graphics::TColor Value);
  void __fastcall SetTabInactiveFont(Graphics::TFont* Value);
  HIDESBASE void __fastcall SetTabIndex(int Value);
  void __fastcall SetTabPosition(TExtTabPosition Value);
  void __fastcall SetTabStyle(TExtTabStyle Value);
  HIDESBASE void __fastcall SetTabWidth(Word Value);
  void __fastcall SetTabWordWrap(bool Value);
  HIDESBASE MESSAGE void __fastcall CMDialogChar(Messages::TWMKey &Msg);
  HIDESBASE MESSAGE void __fastcall CMFontChanged(Messages::TMessage &Msg);
  MESSAGE void __fastcall CMHintShow(Messages::TMessage &Msg);
  HIDESBASE MESSAGE void __fastcall CMMouseEnter(Messages::TMessage &Msg);
  HIDESBASE MESSAGE void __fastcall CMMouseLeave(Messages::TMessage &Msg);
  HIDESBASE MESSAGE void __fastcall CMParentColorChanged(Messages::TMessage &Msg);
  MESSAGE void __fastcall CNDrawTab(Messages::TWMDrawItem &Msg);
  MESSAGE void __fastcall TCMInsertItem(Messages::TMessage &Msg);
  HIDESBASE MESSAGE void __fastcall WMEraseBkgnd(Messages::TWMEraseBkgnd &Msg);
  HIDESBASE MESSAGE void __fastcall WMLButtonDown(Messages::TWMMouse &Msg);
  HIDESBASE MESSAGE void __fastcall WMNCHitTest(Messages::TWMNCHitTest &Msg);
  HIDESBASE MESSAGE void __fastcall WMPaint(Messages::TWMPaint &Msg);
  
protected:
  virtual void __fastcall ChangeScale(int M, int D);
  virtual void __fastcall CreateParams(Controls::TCreateParams &Params);
  virtual void __fastcall CreateWnd(void);
  virtual void __fastcall FillTabBG(HDC DC, bool ActiveTab, const Windows::TRect &TabRect);
  void __fastcall GlyphHasChanged(System::TObject* Sender);
  void __fastcall GlyphHasChangedPicture(System::TObject* Sender);
  virtual void __fastcall Loaded(void);
  virtual void __fastcall TabFontChanged(System::TObject* Sender);
  virtual tagPOINT __fastcall TabTextOut(const Windows::TRect &Rect, const tagPOINT &Margin,  System::AnsiString 
    Text, Classes::TAlignment Align, bool Disabled);
  
public:
  bool PaintFlickerFree;
  __fastcall virtual TExtTabControl(Classes::TComponent* AOwner);
  __fastcall virtual ~TExtTabControl(void);
  virtual void __fastcall BeginUpdate(void);
  virtual void __fastcall DefaultDrawTab(int Index, const Windows::TRect &RectFg, Stdctrls::TOwnerDrawState 
    State);
  virtual void __fastcall DrawTab(int Index, bool ActiveTab, const Windows::TRect &RectFg, const Windows::TRect 
    &RectBg, Stdctrls::TOwnerDrawState State);
  virtual void __fastcall EndUpdate(void);
  virtual int __fastcall GetGlyphIndex(int TabIndex);
  virtual void __fastcall GetSheetRect(Windows::TRect &SheetRect);
  virtual int __fastcall GetTabNumber(const tagPOINT &CurrentPos);
  virtual Windows::TRect __fastcall GetTabRect(int TabIndex);
  virtual void __fastcall HottrackChange(int Cold, int Hot);
  bool __fastcall IsNewComCtl(void);
  __property Graphics::TCanvas* Canvas = {read=FCanvas, nodefault};
  __property bool TabEnabled[int Index] = {read=GetTabEnabled, write=SetTabEnabled};
  __property Tabs ;
  
__published:
  __property Color ;
  __property TExtHottrack* Hottrack = {read=FHottrack, write=SetHottrack, nodefault};
  __property ParentColor ;
  __property Graphics::TColor TabActiveColor = {read=FTabActiveColor, write=SetTabActiveColor, nodefault
    };
  __property Graphics::TFont* TabActiveFont = {read=FTabActiveFont, write=SetTabActiveFont, nodefault
    };
  __property TExtGlyphs* TabGlyphs = {read=FTabGlyphs, write=SetTabGlyphs, nodefault};
  __property Word TabHeight = {read=FTabHeight, write=SetTabHeight, nodefault};
  __property Classes::TStringList* TabHints = {read=FTabHints, write=SetTabHints, nodefault};
  __property Graphics::TColor TabInactiveColor = {read=FTabInactiveColor, write=SetTabInactiveColor, 
    nodefault};
  __property Graphics::TFont* TabInactiveFont = {read=FTabInactiveFont, write=SetTabInactiveFont, nodefault
    };
  __property int TabIndex = {read=GetTabIndex, write=SetTabIndex, nodefault};
  __property TExtTabPosition TabPosition = {read=FTabPosition, write=SetTabPosition, default=2};
  __property TExtTabStyle TabStyle = {read=FTabStyle, write=SetTabStyle, default=0};
  __property Word TabWidth = {read=FTabWidth, write=SetTabWidth, nodefault};
  __property bool TabWordWrap = {read=FTabWordWrap, write=SetTabWordWrap, default=0};
  __property TExtDrawBkgndInside OnDrawBkgndInside = {read=FOnDrawBkgndInside, write=FOnDrawBkgndInside
    };
  __property TExtDrawBkgndOutside OnDrawBkgndOutside = {read=FOnDrawBkgndOutside, write=FOnDrawBkgndOutside
    };
  __property TExtNbDrawTabEvent OnDrawTab = {read=FOnDrawTab, write=FOnDrawTab};
public:
  /* TWinControl.CreateParented */ __fastcall TExtTabControl(HWND ParentWindow) : Comctrls::TTabControl(
    ParentWindow) { }
  
};

//-- var, const, procedure ---------------------------------------------------
#define TCS_BOTTOM (Byte)(2)
#define TCS_RIGHT (Byte)(2)
#define TCS_VERTICAL (Byte)(128)
#define TCS_FLATBUTTONS (Byte)(8)
extern void __fastcall ExtDrawBkgndImage(Controls::TWinControl* Control, int /*HDC*/ DC, const Windows::TRect 
  &RectBg, Extctrls::TImage* ImageBg);
extern void __fastcall ExtDrawBkgndImageRgn(Controls::TWinControl* Control, int /*HDC*/ DC, int /*HRGN*/ RgnBg, Extctrls::TImage* 
  ImageBg);
extern void __fastcall ExtDrawTabGraphic(Graphics::TCanvas* Canvas, Graphics::TGraphic* Graphic, const 
  Windows::TRect &RectBg, bool Stretch);
extern void __fastcall ExtStretchBlt(int /*HDC*/ DC, const Windows::TRect &Dest, Graphics::TGraphic* Graphic
  , int SrcLeft, int SrcTop, int SrcWidth, int SrcHeight, int CopyMode, int StretchWidth, int StretchHeight
  );
extern void __fastcall Register(void);

} /* namespace Extpage */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Extpage;
#endif
//-- end unit ----------------------------------------------------------------
#endif  // ExtPage
