unit DTEditors;

interface

{$INCLUDE ProHelp.inc}

uses
  DsgnIntf,
  Classes,
  ComCtrls,
  NWControls,
  SysUtils;

type

 TigToolBarEditor = class(TDefaultEditor)
    public
      function GetVerb(Index: Integer): string; override;
      function GetVerbCount: Integer; override;
      procedure ExecuteVerb(Index: Integer); override;
    end;

  TigToolButtonEditor = class(TigToolBarEditor)
    public
      procedure ExecuteVerb(Index: Integer); override;
    end;

function AddButton(Designer: {$IFNDEF DELPHI40}  TFormDesigner {$ELSE} IFormDesigner {$ENDIF}; ToolBar: TigToolBar): TComponent;
function AddSeparator(Designer: {$IFNDEF DELPHI40}  TFormDesigner {$ELSE} IFormDesigner {$ENDIF}; ToolBar: TigToolBar): TComponent;

implementation

type

TigToolButton = class(NWControls.TigToolButton)
    published
      property Style stored True;
      property Width stored True;
    public
      constructor Create(AOwner: TComponent); override;
end;

function AddButton(Designer: {$IFNDEF DELPHI40}  TFormDesigner {$ELSE} IFormDesigner {$ENDIF};
                   ToolBar: TigToolBar): TComponent;
begin
   Result := Designer.CreateComponent(NWControls.TigToolButton,ToolBar,
         ToolBar.Width-1,      //Left
         ToolBar.Height-1,     //Top
         ToolBar.ButtonWidth,  //Width,
         ToolBar.ButtonHeight  //Height
    );
end;

function AddSeparator(Designer: {$IFNDEF DELPHI40}  TFormDesigner {$ELSE} IFormDesigner {$ENDIF};
  ToolBar: TigToolBar): TComponent;
begin
   Result := Designer.CreateComponent(TigToolButton,ToolBar,
         ToolBar.Width-1,      //Left
         ToolBar.Height-1,     //Top
         8,                    //Width,
         ToolBar.ButtonHeight  //Height
    );
end;

function TigToolBarEditor.GetVerb(Index: Integer): string;
begin
  if Index = 0 then Result := 'New B&utton'
  else Result := 'New Se&parator'
end;

function TigToolBarEditor.GetVerbCount: Integer;
begin
  Result := 2;
end;

procedure TigToolBarEditor.ExecuteVerb(Index: Integer);
begin
 if Index = 0 then
   AddButton(Designer,TigToolBar(Component))
 else begin
   AddSeparator(Designer,TigToolBar(Component));
 end;
end;

procedure TigToolButtonEditor.ExecuteVerb(Index: Integer);
begin
 if Index = 0 then
   AddButton(Designer,TigToolBar(TigToolButton(Component).Parent))
 else begin
   AddSeparator(Designer,TigToolBar(DTEditors.TigToolButton(Component).Parent));
 end;
end;

constructor TigToolButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Style :=  tbsSeparator;
  Width := 8;
end;

end.
