unit Modal;
                { Copyright  1998 by Igor Glukhov}
                     { Project name: ProHelp}
interface

uses  
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ProHelp, ExtCtrls, Buttons, StdCtrls, ComCtrls, NWControls;
type
  TModalForm = class(TForm)
    cbNonStopHelp: TCheckBox;
    cbPopUpWhatIsThis: TCheckBox;
    cbMenuRButtonHelp: TCheckBox;
    cbPopUpIsDefaultWnd: TCheckBox;
    cbCheckHCSign: TCheckBox;
    cbBeepIfNoHelp: TCheckBox;
    cbUseSystemStdTopics: TCheckBox;
    cbAutoHelpButton: TCheckBox;
    cbNCObjHints: TCheckBox;
    cbSmallCursor: TCheckBox;
    cbUseHelpFinderCmd: TCheckBox;
    cbMainFrmRButtonHelp: TCheckBox;
    cbDlgForceSmallCursor: TCheckBox;
    cbDlgAllowNonStop: TCheckBox;
    cbDlgAllowHelpMode: TCheckBox;
    cbDlgCheckHelpButton: TCheckBox;
    cbMainForm: TCheckBox;
    cbPopUpStdTopics: TCheckBox;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Panel1: TPanel;
    GroupBox10: TGroupBox;
    Shape1: TigShape;
    Image1: TigImage;
    Label2: TigLabel;
    GroupBox8: TGroupBox;
    ApplyButton: TButton;
    CancelButton: TButton;
    OKButton: TButton;
    HelpButton: TButton;
    CloseButton: TButton;
    tbDev2: TBevel;
    PasteSB: TigSpeedButton;
    CopySB: TigSpeedButton;
    CutSB: TigSpeedButton;
    UndoSB: TigSpeedButton;
    tbDev3: TBevel;
    PrintPreviewSB: TigSpeedButton;
    PrintSB: TigSpeedButton;
    tbDev1: TBevel;
    CloseSB: TigSpeedButton;
    SaveSB: TigSpeedButton;
    OpenSB: TigSpeedButton;
    NewSB: TigSpeedButton;
    gbComments: TGroupBox;
    Bevel1: TBevel;
    gbControlFlags: TGroupBox;
    GroupBox4: TGroupBox;
    FastLearnButton: TButton;
    ResetButton: TButton;
    Label12: TigLabel;
    Label1: TLabel;
    Label3: TLabel;
    igLabel1: TigLabel;
    igLabel2: TigLabel;
    igLabel3: TigLabel;
    igHelpButton1: TigHelpButton;
    procedure CheckBoxStateChanged(Sender: TObject);
    procedure UpdateCheckBoxes(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CloseButtonClick(Sender: TObject);
    procedure cbMainFormClick(Sender: TObject);
    procedure ResetButtonClick(Sender: TObject);
    procedure FastLearnButtonClick(Sender: TObject);
    procedure Label4Click(Sender: TObject);
    procedure Label6Click(Sender: TObject);
    procedure Label9Click(Sender: TObject);
    procedure Label15Click(Sender: TObject);
    procedure Label18Click(Sender: TObject);
    procedure Label22Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ModalForm: TModalForm;

implementation

uses Main;

{$R *.DFM}

procedure TModalForm.CheckBoxStateChanged(Sender: TObject);
begin
  MainForm.CheckBoxStateChanged(Sender);
end;

procedure TModalForm.UpdateCheckBoxes(Sender: TObject);
begin
   MainForm.ResetDefaults(Sender);
end;

procedure TModalForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  with MainForm do begin
    ExecuteWinHelpMacro(WH_CLOSE_ALL); //CloseHelpWindows;
    miOperatingMode.Checked := False;
    ResetControlItems(True);
    ResetDefaults(MainForm);
  end;
end;

procedure TModalForm.CloseButtonClick(Sender: TObject);
begin
   Close;
end;

procedure TModalForm.cbMainFormClick(Sender: TObject);
var
 MForm: TForm;
begin
 MForm := ModalForm;
 if not TCheckBox(Sender).Checked then MForm := MainForm;
 MainForm.igHelpMonitor1.MainForm := MForm;
 MainForm.MainFormChanged(ModalForm);
end;

procedure TModalForm.ResetButtonClick(Sender: TObject);
begin
  MainForm.ExecuteWinHelpMacro(WH_CLOSE_ALL); //MainForm.CloseHelpWindows;
  MainForm.ResetDefaults(ModalForm);
end;

procedure TModalForm.FastLearnButtonClick(Sender: TObject);
begin
  MainForm.FastLearnButtonClick(nil);
end;

procedure TModalForm.Label4Click(Sender: TObject);
begin
  DBActCounter := 0;
  MainForm.ExecuteWinHelpMacro('JI("ProHelp.hlp>RWnd","M_210")');
end;

procedure TModalForm.Label6Click(Sender: TObject);
begin
  DBActCounter := 0;
  MainForm.ExecuteWinHelpMacro('JI("ProHelp.hlp>RWnd","M_220")');
end;

procedure TModalForm.Label9Click(Sender: TObject);
begin
  DBActCounter := 0;
  WinHelp(Self.Handle,'ProHelp.hlp',HELP_FINDER,0);
end;

procedure TModalForm.Label15Click(Sender: TObject);
begin
  DBActCounter := 0;
  MainForm.ExecuteWinHelpMacro('JI("ProHelp.hlp>RWnd","M_455")');
end;

procedure TModalForm.Label18Click(Sender: TObject);
begin
 DBActCounter := 0;
 MainForm.ExecuteWinHelpMacro('JI("ProHelp.hlp>RWnd","IDH_APP_HMB")');
end;

procedure TModalForm.Label22Click(Sender: TObject);
begin
 DBActCounter := 0;
 MainForm.ExecuteWinHelpMacro('JI("ProHelp.hlp>RWnd","M_10")');
end;

procedure TModalForm.FormCreate(Sender: TObject);
begin
 MainForm.SetHandPointCursor(gbComments);
end;

end.
