unit ExtPgCo1;

// this example demonstrates how to display colored tabs AND sheets

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtPage, StdCtrls;

type
  TForm1 = class(TForm)
    ExtPageControl1: TExtPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    procedure ExtPageControl1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ExtPageControl1DrawTab(Control: TWinControl; Index: Integer;
      ActiveTab: Boolean; const RectFg, RectBg: TRect;
      State: TOwnerDrawState);
  private
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const MySheetColors: Array[0..4] of TColor =
  (clOlive, clYellow, $00F0CAA6, $0080FF80, clRed);

procedure TForm1.ExtPageControl1Change(Sender: TObject);
begin
  // change the color of the TabSheet while switching
  with TExtPageControl(Sender) do
    Color:= MySheetColors[ActivePage.PageIndex];
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  // force the right sheet color
  ExtPageControl1Change(ExtPageControl1);
end;

procedure TForm1.ExtPageControl1DrawTab(Control: TWinControl;
  Index: Integer; ActiveTab: Boolean; const RectFg, RectBg: TRect;
  State: TOwnerDrawState);
begin
  // paint the tabs colored
  with TExtPageControl(Control) do begin
    Canvas.Brush.Color:= MySheetColors[Index];
    Canvas.FillRect(RectBg);
    DefaultDrawTab(Index, RectFg, State);
  end;
end;

end.
