unit Tiled1;

// this example shows a Form + PageControl with tiled bitmap as background

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtPage, ExtCtrls;

type
  TForm1 = class(TForm)
    ExtPageControl1: TExtPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure ExtPageControl1DrawBkgndOutside(Control: TWinControl; DC,
      RgnBg: Integer);
  private
    BackgroundBitmap: TBitmap;
    PgCtrlImage: TImage;
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  BackgroundBitmap:= TBitmap.Create;
  BackgroundBitmap.LoadFromFile(ExtractFilePath(Application.ExeName) + 'CASTLE.BMP');
  // create Image object for PageControl
  PgCtrlImage:= TImage.Create(Self);
  with PgCtrlImage do begin
    Parent:= Self;
    Visible:= False;
    Picture.Bitmap.Height:= ExtPageControl1.Top + ExtPageControl1.Height;
    Picture.Bitmap.Width:= ExtPageControl1.Left + ExtPageControl1.Width;
    Self.Perform(WM_PAINT, PgCtrlImage.Picture.Bitmap.Canvas.Handle, 0);
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  BackgroundBitmap.Free;
end;

procedure TForm1.FormPaint(Sender: TObject);
var
  x, y: Integer;
begin
  // paint the tiled bimtap on the background of the form
  y := 0;
  while y < ClientHeight do begin
    x := 0;
    while x < ClientWidth do begin
      Canvas.Draw(x, y, BackgroundBitmap);
      inc(x, BackgroundBitmap.Width);
    end;
    inc(y, BackgroundBitmap.Height);
  end;
end;

procedure TForm1.ExtPageControl1DrawBkgndOutside(Control: TWinControl; DC,
  RgnBg: Integer);
begin
  ExtDrawBkgndImageRgn(Control, DC, RgnBg, PgCtrlImage);
end;

end.
