unit VERTIC1;

// this sample shows hot to write vertical text on tabs

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtPage, StdCtrls;

type
  TForm1 = class(TForm)
    ExtPageControl1: TExtPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    ExtPageControl2: TExtPageControl;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    procedure ExtPageControl1DrawTab(Control: TWinControl; Index: Integer;
      ActiveTab: Boolean; const RectFg, RectBg: TRect;
      State: TOwnerDrawState);
    procedure ExtPageControl2DrawTab(Control: TWinControl; Index: Integer;
      ActiveTab: Boolean; const RectFg, RectBg: TRect;
      State: TOwnerDrawState);
  private
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function CreateRotatedFont(F: TFont; Angle: Integer): HFont;
var
  LF : TLogFont;
begin
  FillChar(LF, SizeOf(LF), #0);
  with LF do begin
    lfHeight           := F.Height;
    lfWidth            := 0;
    lfEscapement       := Angle*10;
    lfOrientation      := 0;
    if fsBold in F.Style then
      lfWeight         := FW_BOLD
    else
      lfWeight         := FW_NORMAL;
    lfItalic           := Byte(fsItalic in F.Style);
    lfUnderline        := Byte(fsUnderline in F.Style);
    lfStrikeOut        := Byte(fsStrikeOut in F.Style);
    lfCharSet          := DEFAULT_CHARSET;
    StrPCopy(lfFaceName, F.Name);
    lfQuality          := DEFAULT_QUALITY;
    lfOutPrecision     := OUT_DEFAULT_PRECIS;
    lfClipPrecision    := CLIP_DEFAULT_PRECIS;
    case F.Pitch of
      fpVariable : lfPitchAndFamily := VARIABLE_PITCH;
      fpFixed    : lfPitchAndFamily := FIXED_PITCH;
    else
      lfPitchAndFamily := DEFAULT_PITCH;
    end;
  end;
  Result:= CreateFontIndirect(LF);
end;

procedure TForm1.ExtPageControl1DrawTab(Control: TWinControl;
  Index: Integer; ActiveTab: Boolean; const RectFg, RectBg: TRect;
  State: TOwnerDrawState);
begin
  with TExtPageControl(Control) do begin
    // Vertical text (90 degrees)
    Canvas.Font.Handle:= CreateRotatedFont(Canvas.Font, 90);
    // set Text-Alignment to center
    SetTextAlign(Canvas.Handle, TA_CENTER);
    ExtTextOut(Canvas.Handle, 
       RectFg.Left + (RectFg.Right - RectFg.Left) div 2 - 5,
       RectFg.Top + (RectFg.Bottom-RectFg.Top) div 2,
       ETO_CLIPPED, @RectFg, PChar(Pages[Index].Caption),
       Length(Pages[Index].Caption), nil);
  end;
end;

procedure TForm1.ExtPageControl2DrawTab(Control: TWinControl;
  Index: Integer; ActiveTab: Boolean; const RectFg, RectBg: TRect;
  State: TOwnerDrawState);
begin
  with TExtPageControl(Control) do begin
    // Vertical text (270 degrees)
    Canvas.Font.Handle:= CreateRotatedFont(Canvas.Font, 270);
    // set Text-Alignment to center
    SetTextAlign(Canvas.Handle, TA_CENTER);
    ExtTextOut(Canvas.Handle, 
       RectFg.Left + (RectFg.Right - RectFg.Left) div 2 + 10, 
       RectFg.Top + (RectFg.Bottom-RectFg.Top) div 2, 
       ETO_CLIPPED, @RectFg, PChar(Pages[Index].Caption),
       Length(Pages[Index].Caption), nil);
  end;
end;

end.
