/*
   Borland C++ Builder TClipboardViewer component
   Version 1.0

   Copyright (C) Marcel de Kogel 1997
   e-mail: dekogel@giganda.komkon.org
   web: http://www.komkon.org/~dekogel

     You are not allowed to distribute this software commercially
     Please, notify me, if you make any changes to this file

   Methods:
     TClipboardViewer(TComponent *Owner) - Constructor
     ~TClipboardViewer() - Destructor
   Properties:
     bool enabled - Enables or disables TClipboardViewer events
   Events:
     TNotifyEvent OnDrawClipboard - Called when the clipboard has changed

   Revisions:
   1.0  30-07-1997  Initial release
*/
//---------------------------------------------------------------------------
#ifndef TClipboardViewerH
#define TClipboardViewerH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
//---------------------------------------------------------------------------
class TClipboardViewer : public TComponent
{
private:
    HWND FHandle;
    TNotifyEvent FOnDrawClipboard;
    bool FEnabled;
protected:
public:
	__fastcall TClipboardViewer(TComponent* Owner);
	__fastcall ~TClipboardViewer();
__published:
    __property TNotifyEvent OnDrawClipboard = { read=FOnDrawClipboard, write=FOnDrawClipboard };
    __property bool Enabled = { read=FEnabled, write=FEnabled, default=true };
};
//---------------------------------------------------------------------------
#endif
