/*
   Borland C++ Builder TFloatUpDown component
   Version 1.0

   Copyright (C) Marcel de Kogel 1998
   e-mail: dekogel@giganda.komkon.org
   web: http://www.komkon.org/~dekogel

     You are not allowed to distribute this software commercially
     Please, notify me, if you make any changes to this file

   TFloatUpDown is similar to TUpDown, but with the following differences:
   - Property Thousands is not supported
   - The following integer properties have been replaced with double precision
     properties:
	 - Min / FloatMin
     - Max / FloatMax
     - Increment / FloatIncrement
     - Position / FloatPosition
   - The following events have been renamed:
     - OnChanging / OnFloatChanging
     - OnClick / OnFloatClick
     OnFloatClick is called first, immediately followed by OnFloatChanging
     (This doesn't work properly with TUpDown)
   - The property Associate is renamed to FloatAssociate

   TFloatUpDown supports regional settings for floating point number notations

   Revisions:
   1.0  14-09-1998  Initial release
*/
//---------------------------------------------------------------------------
#ifndef TFloatUpDownH
#define TFloatUpDownH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ComCtrls.hpp>
//---------------------------------------------------------------------------
class TFloatUpDown : public TCustomUpDown
{
private:
	double FFloatMin;
    double FFloatMax;
    double FFloatIncrement;
    double FFloatPosition;
    TUDChangingEvent FOnFloatChanging;
    TUDClickEvent FOnFloatClick;
    TWinControl *FFloatAssociate;
    void __fastcall CustomUpDownChanging(TObject *Sender,bool &AllowChange);
    void __fastcall CustomUpDownClick(TObject *Sender,TUDBtnType Button);
    void __fastcall SetFloatMin(double FloatMin);
    void __fastcall SetFloatMax(double FloatMax);
    void __fastcall SetFloatIncrement(double FloatIncrement);
    void __fastcall SetFloatPosition(double FloatPosition);
    void __fastcall SetOnFloatChanging(TUDChangingEvent OnFloatChanging);
    void __fastcall SetOnFloatClick(TUDClickEvent OnFloatClick);
    void __fastcall SetFloatAssociate(TWinControl *FloatAssociate);
protected:
public:
	__fastcall TFloatUpDown(TComponent* Owner);
__published:
	__property AlignButton;
	__property TWinControl *FloatAssociate = { read=FFloatAssociate, write=SetFloatAssociate };
	__property ArrowKeys;
	__property Enabled;
	__property Hint;
	__property double FloatMin = { read=FFloatMin, write=SetFloatMin };
	__property double FloatMax = { read=FFloatMax, write=SetFloatMax };
	__property double FloatIncrement = { read=FFloatIncrement, write=SetFloatIncrement };
	__property Orientation;
	__property ParentShowHint;
	__property PopupMenu;
	__property double FloatPosition = { read=FFloatPosition, write=SetFloatPosition };
	__property ShowHint;
	__property TabOrder;
	__property TabStop;
//	__property Thousands;
	__property Visible;
	__property Wrap;
	__property TUDChangingEvent OnFloatChanging = { read=FOnFloatChanging, write=SetOnFloatChanging };
	__property TUDClickEvent OnFloatClick = { read=FOnFloatClick, write=SetOnFloatClick };
	__property OnEnter;
	__property OnExit;
	__property OnMouseDown;
	__property OnMouseMove;
	__property OnMouseUp;
};
//---------------------------------------------------------------------------
#endif
